#include <vector>
#include <match.hh>

class scsi_module {
public:

  size_t type;
  std::string module;

  bool operator== (const scsi_module& other);

  void read_from_sysfs (const std::string& file);
  void read_from_proc (const std::string& file);
  void read_from_env ();
};

std::ostream& operator<< (std::ostream& os, const scsi_module& module);

class scsi_subsystem : public basic_subsystem
{
public:
  
  virtual ~scsi_subsystem  () {}
  
  virtual std::string name () { return "scsi"; }
  
  virtual void hotplug ();
  virtual void hotplug_all ();
  virtual void list ();
  
private:

  void hotplug (const scsi_module& m);
  void list (const scsi_module& m);

  void match_modules (scsi_module& m,
		      void(scsi_subsystem::*op)(const scsi_module&));
  
  void parse_modules ();
  void for_each (void(scsi_subsystem::*op)(const scsi_module&));
  
  static std::vector<scsi_module> modules;
};
